//	X^[gj[Visual C++̃R}hvvg𒊏ow肵R}hs
//	2015/04/18

#include <windows.h>
#include <stdio.h>
#include <shlobj.h>
#include <shobjidl.h>
#include <shlguid.h>
#include <ctype.h>
#include <tchar.h>
#include <vector>
#include "resource.h"

using namespace std;

struct VC_CMD{
	TCHAR* fpass;	//	tpX
	TCHAR* spass;	//	V[gpX
	TCHAR* cmd;		//	R}he
	TCHAR* opt;		//	R}hIvV
	TCHAR* batfile[2];	//	ob`t@C  [X/fobN
	int ver;		//	Visual C++ o[W	2005/2008/2010/2013
	int bit;		//	rbg 32/64
};


vector<VC_CMD> vc_cmd;	//	R}hvvgւ̃V[gJbg̃pX̔z

TCHAR path[MAX_PATH];	//	X^[gj[ւ̃pX

TCHAR def_dir[MAX_PATH];	//	tH_[

//	_CAO{bNXvV[W[

LRESULT CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

//	X^[gj[Visual C++̃R}hvvg̃ob`t@Cւ̃pX擾
int chk_vc_cmd(void);

//	X^[gj[Visual C++̃R}hvvgւ̃V[gJbg擾
int find_vc(IShellLink *m_pShellLink, IPersistFile *m_pPersistFile, TCHAR* pass);

//	Visual C++̃tH_[̏ꍇAtrueԂ
bool vc_dir_chk(TCHAR* str);

//	Visual C++̃tH_[̃c[oꍇtrueԂ
bool vc_tool_dir_chk(TCHAR* str);

//	R}h쐬
TCHAR* make_cmd_str(TCHAR* cmd, int cmdMax, int num, TCHAR* add_cmd, TCHAR* build);

//	V[gJbg̃N̎擾
TCHAR* link_target(IShellLink *m_pShellLink, IPersistFile *m_pPersistFile, TCHAR* pass, TCHAR* link);

//	Visual C++̃o[Wԍ擾
int get_vc_ver(TCHAR* str);

//	R}hCIvVrbg擾
int get_vc_bit(TCHAR* str);

//	R}hŎw肵ϐ̓WJ
void arg_rep(VC_CMD& vc_cmd, TCHAR* cmd, TCHAR* parse);

//	R}hCIvVob`t@C𒊏o
TCHAR* cmd_opt2bat(TCHAR* src);

//	fBNg擾R_CAO\
int GetDir(HWND hWnd, TCHAR* path);

//	L_CAÕR[obN֐
int __stdcall BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData);

int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, TCHAR* CmdLine, int nCmdShow){
	chk_vc_cmd();
	_tcscpy_s(::def_dir, sizeof(::def_dir) / sizeof(TCHAR), _TEXT(""));
	DialogBox(hCurInst, TEXT("DLG1"), 0, (DLGPROC)DlgProc);
	return 0;
}

//	_CAO{bNXvV[W[

LRESULT CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	static HWND hList;
	DWORD dwStyle;
	TCHAR pass[MAX_PATH];
	LPNMHDR lpnmhdr;
	LPNMLISTVIEW lpnmlv;
	int i, bat_max;
	unsigned int n;
	unsigned int flags;

	switch (msg) {
	case WM_INITDIALOG:{	//	_CAOɌĂяo
		hList = GetDlgItem(hDlg, IDC_VC_CMD_LISTVIEW);	//	Xgr[nh擾
		dwStyle = ListView_GetExtendedListViewStyle(hList);
		dwStyle |= LVS_EX_CHECKBOXES | LVS_EX_FULLROWSELECT |
			LVS_EX_GRIDLINES;
		ListView_SetExtendedListViewStyle(hList, dwStyle);

		LV_COLUMN lvcol;

		lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
		lvcol.fmt = LVCFMT_LEFT;
		lvcol.cx = 384;
		lvcol.pszText = _TEXT("");
		lvcol.iSubItem = 0;
		ListView_InsertColumn(hList, 0, &lvcol);
		lvcol.cx = 192;
		lvcol.pszText = _TEXT("R}h");
		lvcol.iSubItem = 1;
		ListView_InsertColumn(hList, 1, &lvcol);

		lvcol.cx = 512;
		lvcol.pszText = _TEXT("IvV");
		lvcol.iSubItem = 2;
		ListView_InsertColumn(hList, 2, &lvcol);

		lvcol.cx = 640;
		lvcol.pszText = _TEXT("ꏊ");
		lvcol.iSubItem = 3;
		ListView_InsertColumn(hList, 3, &lvcol);

		LV_ITEM item;
		ZeroMemory(&item, sizeof(LV_ITEM));
		int i = 0;
		for (unsigned int n = 0; n<vc_cmd.size(); n++){
			if (vc_cmd[n].bit){
				item.mask = LVIF_TEXT;
				item.pszText = vc_cmd[n].spass;
				item.iItem = i++;
				item.iSubItem = 0;
				ListView_InsertItem(hList, &item);

				item.pszText = vc_cmd[n].cmd;
				item.iSubItem = 1;
				ListView_SetItem(hList, &item);

				item.pszText = vc_cmd[n].opt;
				item.iSubItem = 2;
				ListView_SetItem(hList, &item);

				item.pszText = vc_cmd[n].fpass;
				item.iSubItem = 3;
				ListView_SetItem(hList, &item);
			}
		}
		return TRUE;
	}
	case WM_NOTIFY:	//	RRg[̃bZ[W󂯎
		lpnmhdr = (LPNMHDR)lParam;
		if ((int)wParam == IDC_VC_CMD_LISTVIEW){	//	Xgr[ւ̃bZ[W
			switch (lpnmhdr->code){
			case NM_CLICK:{		//	[U[Rg[ō{^NbN	s̑I
				lpnmlv = (LPNMLISTVIEW)lParam;
				TCHAR cmd[1024];
				TCHAR add_cmd[256];
				if (0<=lpnmlv->iItem){
					GetWindowText(GetDlgItem(hDlg, IDC_CMD_EDIT), add_cmd, sizeof(add_cmd) / sizeof(TCHAR));
					make_cmd_str(cmd, sizeof(cmd) / sizeof(TCHAR), lpnmlv->iItem, add_cmd, _TEXT("\"));
					SetWindowText(GetDlgItem(hDlg, IDC_BAT_EDIT), cmd);
				}
				break;
			}
			}
		}
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_REF_BUTTON:{	//	tH_[Qƃ{^NbNꍇ
			TCHAR pass[MAX_PATH];
			GetDir(hDlg, pass);
			SetWindowText(GetDlgItem(hDlg, IDC_DIR_EDIT), pass);
			_tcscpy_s(::def_dir, sizeof(::def_dir) / sizeof(TCHAR), pass);
			break;
		}
		case IDC_CMD_EDIT:
			switch (HIWORD(wParam)){
				case EN_UPDATE:{	//	R}hύXꂽꍇ
					GetWindowText(GetDlgItem(hDlg, IDC_DIR_EDIT), ::def_dir, sizeof(::def_dir) / sizeof(TCHAR));
					int n = ListView_GetNextItem(hList, -1, LVNI_ALL | LVNI_SELECTED);
					if (0 <= n){
						TCHAR cmd[1024];
						TCHAR add_cmd[256];
						GetWindowText(GetDlgItem(hDlg, IDC_CMD_EDIT), add_cmd, sizeof(add_cmd) / sizeof(TCHAR));
						make_cmd_str(cmd, sizeof(cmd) / sizeof(TCHAR), n, add_cmd, _TEXT("\"));
						SetWindowText(GetDlgItem(hDlg, IDC_BAT_EDIT), cmd);
					}
					break;
				}
			}
			break;
		case IDC_DIR_EDIT:
			switch (HIWORD(wParam)){
				case EN_UPDATE:{	//	tH_[ύXꂽꍇ
					GetWindowText(GetDlgItem(hDlg, IDC_DIR_EDIT), ::def_dir, sizeof(::def_dir) / sizeof(TCHAR));
					int n = ListView_GetNextItem(hList, -1, LVNI_ALL | LVNI_SELECTED);
					if (0 <= n){
						TCHAR cmd[1024];
						TCHAR add_cmd[256];
						GetWindowText(GetDlgItem(hDlg, IDC_CMD_EDIT), add_cmd, sizeof(add_cmd) / sizeof(TCHAR));
						make_cmd_str(cmd, sizeof(cmd) / sizeof(TCHAR), n, add_cmd, _TEXT("\"));
						SetWindowText(GetDlgItem(hDlg, IDC_BAT_EDIT), cmd);
					}
					break;
				}
			}
			break;
		case IDOK:	//	s{^NbNꂽꍇ
			GetWindowText(GetDlgItem(hDlg, IDC_CMD_EDIT), pass, sizeof(pass) / sizeof(TCHAR));
			i = 0;
			bat_max = 0;
			flags = 0;
			if (BST_CHECKED == SendMessage(GetDlgItem(hDlg, IDC_R_CHECKBOX), BM_GETCHECK, 0, 0))
				flags |= 0x1;
			if (BST_CHECKED == SendMessage(GetDlgItem(hDlg, IDC_D_CHECKBOX), BM_GETCHECK, 0, 0))
				flags |= 0x2;
			TCHAR text[256];
			for (n = 0; n < vc_cmd.size(); n++){
				if (vc_cmd[n].bit){
					ListView_GetItemText(hList, i, 0, text, sizeof(text) / sizeof(TCHAR));
					if (ListView_GetCheckState(hList, i) != 0){	//	`FbN{bNX`FbNĂ
						TCHAR cmd[1024];
						TCHAR fname[MAX_PATH];
						FILE* fp;

						for (int u = 0; u < 2; u++){
							if (u == 0 && (flags & 0x1) == 0){
								vc_cmd[n].batfile[u] = 0;
								continue;
							}
							if (u == 1 && (flags & 0x2) == 0){
								vc_cmd[n].batfile[u] = 0;
								continue;
							}
							if (u == 0 && (flags & 0x1))	//	[X
								make_cmd_str(cmd, sizeof(cmd) / sizeof(TCHAR), i, pass, _TEXT("release"));
							if (u == 1 && (flags & 0x2))	//	fobN
								make_cmd_str(cmd, sizeof(cmd) / sizeof(TCHAR), i, pass, _TEXT("debug"));

							_stprintf_s(fname, sizeof(fname) / sizeof(TCHAR), _TEXT("%d_%d_%d%c.bat"), i, vc_cmd[n].ver, vc_cmd[n].bit, u == 0 ? _T('r') : _T('d'));
							if (_tfopen_s(&fp, fname, _TEXT("w")) == 0){
								vc_cmd[n].batfile[u] = _tcsdup(fname);
#ifdef UNICODE
								char sjis[1024];
								WideCharToMultiByte(CP_ACP, 0, cmd, -1, sjis, sizeof(sjis), NULL, NULL);
								fputs(sjis, fp);
#else
								fputs(cmd, fp);
#endif
								fclose(fp);
								++bat_max;
							}
							else{
								vc_cmd[n].batfile[u] = 0;
								MessageBox(0, text, _TEXT("BATt@C쐬ł܂ł"), MB_OK);
							}
						}
					}
					else{
						vc_cmd[n].batfile[0] = 0;
						vc_cmd[n].batfile[1] = 0;
					}
					++i;
				}
				else{
					vc_cmd[n].batfile[0] = 0;
					vc_cmd[n].batfile[1] = 0;
				}
			}
			SendMessage(GetDlgItem(hDlg, IDC_PROGBAR), PBM_SETRANGE, 0, MAKELPARAM(0, bat_max));
			SendMessage(GetDlgItem(hDlg, IDC_PROGBAR), PBM_SETSTEP, 1, 0);
			i = 0;
			for (n = 0; n < vc_cmd.size(); n++){
				for (int u = 0; u < 2; u++){
					if (vc_cmd[n].batfile[u]){
						_stprintf_s(text, sizeof(text) / sizeof(TCHAR), _TEXT("s Visual C++ %d %dbit %s %d/%d"), vc_cmd[n].ver, vc_cmd[n].bit, u == 0 ? _TEXT("Release") : _TEXT("Debug"), ++i, bat_max);
						SetWindowText(GetDlgItem(hDlg, IDC_RUN_LABEL), text);
						TCHAR* cmd = vc_cmd[n].batfile[u];
						_tsystem(cmd);
						SendMessage(GetDlgItem(hDlg, IDC_PROGBAR), PBM_STEPIT, 0, 0);
					}
				}
			}
			MessageBox(hDlg, _TEXT("I܂"), _TEXT("bZ[W"), MB_OK);
			EndDialog(hDlg, TRUE);
			return TRUE;
		case IDCANCEL:	//	LZ{^NbNꂽꍇ
			EndDialog(hDlg, FALSE);
			return TRUE;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}

//	X^[gj[Visual C++̃R}hvvgւ̃V[gJbg擾

int chk_vc_cmd(void){
	unsigned int n;

	FILE* fp;
	_tfopen_s(&fp, _TEXT("vc.txt"), _TEXT("w,ccs=UNICODE"));
	if (FAILED(CoInitialize(NULL))){	//	COM̏@STAiVOXbhAp[ggj
		MessageBox(0, _TEXT("COM̏Ɏs܂"), _TEXT("G["), MB_OK);
		return -1;
	}
	IShellLink		*m_pShellLink = NULL;
	IPersistFile	*m_pPersistFile = NULL;
	//	IShellLinkIuWFNg쐬
	if (CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID *)&m_pShellLink) == S_OK){
		//	IPersistFileC^[tF[X̍쐬
		if (m_pShellLink->QueryInterface(IID_IPersistFile, (LPVOID *)&m_pPersistFile) == S_OK){
			SHGetSpecialFolderPath(NULL, ::path, CSIDL_COMMON_STARTMENU, 0);
			find_vc(m_pShellLink, m_pPersistFile, ::path);	//	V[gJbg̈ꗗ쐬
			TCHAR link[MAX_PATH];
			for (n = 0; n<vc_cmd.size(); n++){
				if (m_pPersistFile->Load((LPCOLESTR)vc_cmd[n].fpass, STGM_READ) == S_OK){
					if (m_pShellLink->Resolve(NULL, 0) == NOERROR){	//	NɃt@CȂꍇ̓G[bZ[W\
						m_pShellLink->GetPath(link, sizeof(link) / sizeof(TCHAR), NULL, SLGP_UNCPRIORITY);	//	N擾//
						TCHAR opt[MAX_PATH];	//	V[gJbg̃N
						m_pShellLink->GetArguments(opt, MAX_PATH);

						vc_cmd[n].cmd = _tcsdup(link);
						vc_cmd[n].opt = _tcsdup(opt);
						vc_cmd[n].ver = get_vc_ver(vc_cmd[n].spass);
						vc_cmd[n].bit = get_vc_bit(vc_cmd[n].opt);

						_ftprintf(fp, _TEXT("%d,%d,%s,%s,%s,%s\n"), vc_cmd[n].ver, vc_cmd[n].bit, vc_cmd[n].spass, link, opt, vc_cmd[n].fpass);
					}else{
						m_pShellLink->GetPath(link, sizeof(link) / sizeof(TCHAR), NULL, SLGP_UNCPRIORITY);	//	N擾//
						vc_cmd[n].cmd = 0;
						vc_cmd[n].opt = 0;
					}
				}else{
					vc_cmd[n].cmd = 0;
					vc_cmd[n].opt = 0;
				}
			}
			m_pShellLink->Release();	//	IShellLinkIuWFNg̉
			m_pPersistFile->Release();	//	IPersistFileC^[tF[X̉
		}
		CoUninitialize();	//	COM̉
		fclose(fp);
	}
	return 0;

}

//	X^[gj[Visual C++̃R}hvvgւ̃V[gJbg擾
int find_vc(IShellLink *m_pShellLink, IPersistFile *m_pPersistFile, TCHAR* pass){
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	TCHAR find_pass[MAX_PATH];
	int num = 0;	//	t@C

	int len = (int)_tcslen(pass) + 1;
	_stprintf_s(find_pass, sizeof(find_pass) / sizeof(TCHAR), _TEXT("%s\\*.*"), pass);	//	TufBNǧ
	hFind = FindFirstFile(find_pass, &FindFileData);
	if (hFind != INVALID_HANDLE_VALUE){
		do{
			if ((FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){	//	fBNg̏ꍇ
				if (_tcscmp(FindFileData.cFileName, _TEXT("..")) && _tcscmp(FindFileData.cFileName, _TEXT("."))){	//	efBNg͖
					TCHAR prog_pass[MAX_PATH];	//	vOtH_[̃pX
					_stprintf_s(prog_pass, sizeof(prog_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\*.*"), pass, FindFileData.cFileName);
#if 1
					WIN32_FIND_DATA prog_FindFileData;
					HANDLE prog_hFind;
					prog_hFind = FindFirstFile(prog_pass, &prog_FindFileData);
					if (prog_hFind != INVALID_HANDLE_VALUE){
						do{
							if ((prog_FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){	//	fBNg̏ꍇ
								if (_tcscmp(prog_FindFileData.cFileName, _TEXT("..")) && _tcscmp(prog_FindFileData.cFileName, _TEXT("."))){	//	efBNg͖
									if (vc_dir_chk(prog_FindFileData.cFileName) == true){	//	Visual Studio 2013 & Microsoft Visual Studio 2008
#if 2
										TCHAR tool_pass[MAX_PATH];
										_stprintf_s(tool_pass, sizeof(tool_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\%s\\*.*"), pass, FindFileData.cFileName, prog_FindFileData.cFileName);
										WIN32_FIND_DATA tool_FindFileData;
										HANDLE tool_hFind;
										tool_hFind = FindFirstFile(tool_pass, &tool_FindFileData);
										if (tool_hFind != INVALID_HANDLE_VALUE){
											do{
												if (1){	//	tH_[̏ꍇ
													if (_tcsstr(tool_FindFileData.cFileName, _TEXT("vvg"))){	//R}h vvg
														_stprintf_s(tool_pass, sizeof(tool_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\%s\\%s"), pass, FindFileData.cFileName, prog_FindFileData.cFileName, tool_FindFileData.cFileName);
														VC_CMD t;
														t.fpass = _tcsdup(tool_pass);
														t.spass = _tcsdup(tool_FindFileData.cFileName);
														vc_cmd.push_back(t);
													}else

														if (vc_tool_dir_chk(tool_FindFileData.cFileName) == true){
#if 3
															TCHAR cmd_pass[MAX_PATH];
															TCHAR short_pass[MAX_PATH];
															bool short_cut;
															if (_tcsstr(tool_FindFileData.cFileName, _TEXT(".lnk"))){
																_stprintf_s(short_pass, sizeof(short_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\%s\\%s"), pass, FindFileData.cFileName, prog_FindFileData.cFileName, tool_FindFileData.cFileName);
																link_target(m_pShellLink, m_pPersistFile, short_pass, cmd_pass);
																_tcscpy_s(short_pass, sizeof(short_pass) / sizeof(TCHAR), cmd_pass);
																_tcscat_s(cmd_pass, sizeof(cmd_pass) / sizeof(TCHAR), _TEXT("\\*.lnk"));
																short_cut = true;
															}else{
																_stprintf_s(cmd_pass, sizeof(cmd_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\%s\\%s\\*.lnk"), pass, FindFileData.cFileName, prog_FindFileData.cFileName, tool_FindFileData.cFileName);
																short_cut = false;
															}
															WIN32_FIND_DATA cmd_FindFileData;
															HANDLE cmd_hFind;
															cmd_hFind = FindFirstFile(cmd_pass, &cmd_FindFileData);
															if (cmd_hFind != INVALID_HANDLE_VALUE){
																do{
																	if (_tcsstr(cmd_FindFileData.cFileName, _TEXT("vvg"))){	//R}h vvg
																		TCHAR full_pass[MAX_PATH];
																		if (short_cut == true){
																			_stprintf_s(full_pass, sizeof(full_pass) / sizeof(TCHAR), _TEXT("%s\\%s"), short_pass, cmd_FindFileData.cFileName);
																		}else
																			_stprintf_s(full_pass, sizeof(full_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\%s\\%s\\%s"), pass, FindFileData.cFileName, prog_FindFileData.cFileName, tool_FindFileData.cFileName, cmd_FindFileData.cFileName);
																		VC_CMD t;
																		t.fpass = _tcsdup(full_pass);
																		t.spass = _tcsdup(cmd_FindFileData.cFileName);
																		vc_cmd.push_back(t);
																	}
																} while (FindNextFile(cmd_hFind, &cmd_FindFileData));
															}
#endif	//	3
														}
												}
											} while (FindNextFile(tool_hFind, &tool_FindFileData));

										}
#endif	//	2
									}
								}
							}
						} while (FindNextFile(prog_hFind, &prog_FindFileData));

					}
				}
#endif
			}
		} while (FindNextFile(hFind, &FindFileData));
	}
	FindClose(hFind);
	return num;
}

//	Visual C++̃tH_[̏ꍇAtrueԂ

bool vc_dir_chk(TCHAR* str){
	if (_tcsstr(str, _TEXT("Visual Studio")))
		return true;
	if (_tcsstr(str, _TEXT("Visual C++")))
		return true;
	return false;
}

//	Visual C++̃tH_[̃c[oꍇtrueԂ

bool vc_tool_dir_chk(TCHAR* str){
	if (_tcsstr(str, _TEXT("Tools")))
		return true;
	if (_tcsstr(str, _TEXT("c[")))	//Visual Studio c[
		return true;
	return false;
}

//	V[gJbg̃N̎擾

TCHAR* link_target(IShellLink *m_pShellLink, IPersistFile *m_pPersistFile, TCHAR* pass, TCHAR* link){
	if (m_pPersistFile->Load((LPCOLESTR)pass, STGM_READ) == S_OK){
		if (m_pShellLink->Resolve(NULL, 0) == NOERROR){	//	NɃt@CȂꍇ̓G[bZ[W\
			m_pShellLink->GetPath(link, MAX_PATH, NULL, SLGP_UNCPRIORITY);	//	N擾
			return link;
		}
	}
	return 0;
}

//	Visual C++̃o[Wԍ擾

int get_vc_ver(TCHAR* str){
	TCHAR* p = str;
	TCHAR v[16];
	int n = 0;
	bool f = false;
	while (1){
		if (_istdigit(*p)){	//	
			v[n++] = *p;
			f = true;
		}else{
			if (f == true){
				if (n){
					v[n] = _T('\0');
				}
				if (n == 4){
					return _ttoi(v);

				}
				n = 0;
			}
			f = false;
		}
		if (*p == 0)
			break;
		++p;
	}
	return 0;
}

//	R}hCIvVrbg擾

int get_vc_bit(TCHAR* str){
	if (_tcsstr(str, _TEXT("vcvarsall.bat")) == 0)
		return 0;
	if (_tcsstr(str, _TEXT("amd64")))
		return 64;
	else
		return 86;
}


//	R}h쐬

TCHAR* make_cmd_str(TCHAR* cmd, int cmdMax, int num, TCHAR* add_cmd, TCHAR* build){
	unsigned int n = 0, i = 0;

	for (n = 0; n<vc_cmd.size(); n++){
		if (vc_cmd[n].bit){
			if (i == num){
				break;
			}
			++i;
		}
	}
	TCHAR pass[512];
	arg_rep(vc_cmd[n], add_cmd, pass);

	TCHAR opt[256];
	TCHAR* opt_p;
	_tcscpy_s(opt, sizeof(opt) / sizeof(TCHAR), vc_cmd[n].opt);

	opt_p = cmd_opt2bat(opt);
	if (::def_dir[0])
		_stprintf_s(cmd, cmdMax, _TEXT("rem %s\r\nCALL %s\r\npushd \"%s\"\r\n%s %s\r\n"), vc_cmd[n].spass, opt_p, ::def_dir, pass, build);
	else
		_stprintf_s(cmd, cmdMax, _TEXT("rem %s\r\nCALL %s\r\n%s %s\r\n"), vc_cmd[n].spass, opt_p, pass, build);
	return cmd;
}

//	R}hŎw肵ϐ̓WJ
//	
//	%PLAT%		 x86 or x64
//	%VER%		Visual C++ io[W 2005/2008/2010/2013
//	%IVER%		Visual C++ o[W 8 9 10 11 12
//	%_MSC_VER%	Visual C++ }N _MSC_VERƓl


void arg_rep(VC_CMD& vc_cmd, TCHAR* cmd, TCHAR* parse){
	TCHAR t[MAX_PATH];
	TCHAR* tp = t;
	int f = 0;
	TCHAR* p = cmd;
	TCHAR* fp = 0;	//	%̍ŏ̈ʒu
	TCHAR* pp = parse;
	while (*p){
		if (*p == _T('%')){
			switch (f){
			case 0:	//	%Jn
				fp = p;
				f = 1;
				break;
			case 1:
				if (fp + 1 == p){	//	O%ł邽%i[
					f = 0;
				}else{	//	̏I
					*tp = 0;
					if (_tcscmp(t, _TEXT("PLAT")) == 0){
						if (vc_cmd.bit == 86){
							_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("x86"));
							pp += 3;

						}else{
							_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("x64"));
							pp += 3;
						}
					}else
						if (_tcscmp(t, _TEXT("IVER")) == 0){
							switch (vc_cmd.ver){
							case 2005:
								_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("8"));
								pp += 1;
								break;
							case 2008:
								_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("9"));
								pp += 1;
								break;
							case 2010:
								_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("10"));
								pp += 2;
								break;
							case 2012:
								_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("11"));
								pp += 2;
								break;
							case 2013:
								_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("12"));
								pp += 2;
								break;
							}
						}else
							if (_tcscmp(t, _TEXT("PVER")) == 0){
								switch (vc_cmd.ver){
								case 2005:
									_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("2005"));
									pp += 4;
									break;
								case 2008:
									_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("2008"));
									pp += 4;
									break;
								case 2010:
									_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("2010"));
									pp += 4;
									break;
								case 2012:
									_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("2012"));
									pp += 4;
									break;
								case 2013:
									_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("2013"));
									pp += 4;
									break;
								}
							}else
								if (_tcscmp(t, _TEXT("_MSC_VER")) == 0){
									switch (vc_cmd.ver){
									case 2005:
										_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("1400"));
										pp += 4;
										break;
									case 2008:
										_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("1500"));
										pp += 4;
										break;
									case 2010:
										_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("1600"));
										pp += 4;
										break;
									case 2012:
										_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("1700"));
										pp += 4;
										break;
									case 2013:
										_tcscpy_s(pp, parse + MAX_PATH - pp, _TEXT("1800"));
										pp += 4;
										break;
									}
								}
					f = 0;
					tp = t;
				}
				break;
			}
		}else{
			if (f == 1){
				*tp = *p;
				++tp;
			}else
				*pp++ = *p;
		}
		++p;
	}
	*pp = 0;
}

//	R}hCIvVob`t@C𒊏o
TCHAR* cmd_opt2bat(TCHAR* src){
	TCHAR* p = src;
	TCHAR* top = src;
	if (_tcsncmp(src, _TEXT("/k"), 2) == 0){	//	/kIvVŊJn
		p = src + 3;
		top = p;
	}
	//	󔒂𖳎
	while (*p){
		if (*p != _T(' ')){
			top = p;
			break;
		}
		++p;
	}
	//	擪"""ɒu
	if (_tcsncmp(top, _TEXT("\"\""), 2) == 0){
		++top;
		++p;
	}
	while (*p){
		if (_tcsncmp(p, _TEXT("\"\""), 2) == 0){
			++p;
			*p = _T(' ');
		}
		++p;
	}
	return top;
}

//	fBNg擾R_CAO\


int GetDir(HWND hWnd, TCHAR* path){
	BROWSEINFO bInfo;
	LPITEMIDLIST pIDList;
	bInfo.hwndOwner = hWnd; // _CAO̐eEChẼnh 
	bInfo.pidlRoot = NULL; // [gtH_fXNgbvtH_Ƃ 
	bInfo.pszDisplayName = path; //szDisplayName; // tH_󂯎obt@ւ̃|C^ 
	bInfo.lpszTitle = TEXT("ۑtH_̑I"); // c[r[̏㕔ɕ\镶 
	bInfo.ulFlags = BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE; // \tH_̎ނtO 
	bInfo.lpfn = BrowseCallbackProc; // BrowseCallbackProc֐̃|C^ 
	bInfo.lParam = NULL;
	pIDList = SHBrowseForFolder(&bInfo);
	if (pIDList == NULL){
		path[0] = _TEXT('\0');
		return FALSE; //IȂꍇ 
	}else{
		if (!SHGetPathFromIDList(pIDList, path))
			return FALSE;//ϊɎs 
		CoTaskMemFree(pIDList);// pIDList̃J 
		return TRUE;
	}
}
//	L_CAÕR[obN֐

int __stdcall BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData){
	if (uMsg == BFFM_INITIALIZED){
		SendMessage(hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, (LPARAM)def_dir);	//	R_CAȌfBNg
	}
	return 0;
}
